Codeforces Round #467 (Div. 2)-D-Sleepy Game(DFS)

D. Sleepy Game
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Petya and Vasya arranged a game. The game runs by the following rules. Players have a directed graph consisting of n vertices and medges. One of the vertices contains a chip. Initially the chip is located at vertex s. Players take turns moving the chip along some edge of the graph. Petya goes first. Player who can't move the chip loses. If the game lasts for 106 turns the draw is announced.

Vasya was performing big laboratory work in "Spelling and parts of speech" at night before the game, so he fell asleep at the very beginning of the game. Petya decided to take the advantage of this situation and make both Petya's and Vasya's moves.

Your task is to help Petya find out if he can win the game or at least draw a tie.

Input

The first line of input contain two integers n and m — the number of vertices and the number of edges in the graph (2 ≤ n ≤ 105,0 ≤ m ≤ 2·105).

The next n lines contain the information about edges of the graph. i-th line (1 ≤ i ≤ n) contains nonnegative integer ci — number of vertices such that there is an edge from i to these vertices and ci distinct integers ai, j — indices of these vertices (1 ≤ ai, j ≤ nai, j ≠ i).

It is guaranteed that the total sum of ci equals to m.

The next line contains index of vertex s — the initial position of the chip (1 ≤ s ≤ n).

Output

If Petya can win print «Win» in the first line. In the next line print numbers v1, v2, ..., vk (1 ≤ k ≤ 106) — the sequence of vertices Petya should visit for the winning. Vertex v1 should coincide with s. For i = 1... k - 1 there should be an edge from vi to vi + 1 in the graph. There must be no possible move from vertex vk. The sequence should be such that Petya wins the game.

If Petya can't win but can draw a tie, print «Draw» in the only line. Otherwise print «Lose».

Examples
input
Copy
5 6
2 2 3
2 4 5
1 4
1 5
0
1
output
Win
1 2 4 5 
input
Copy
3 2
1 3
1 1
0
2
output
Lose
input
Copy
2 2
1 2
1 1
1
output
Draw
Note

In the first example the graph is the following:

Initially the chip is located at vertex 1. In the first move Petya moves the chip to vertex 2, after that he moves it to vertex 4 for Vasya. After that he moves to vertex 5. Now it is Vasya's turn and there is no possible move, so Petya wins.

In the second example the graph is the following:

Initially the chip is located at vertex 2. The only possible Petya's move is to go to vertex 1. After that he has to go to 3 for Vasya. Now it's Petya's turn but he has no possible move, so Petya loses.

In the third example the graph is the following:

Petya can't win, but he can move along the cycle, so the players will draw a tie.

题意:在一个有向图中,两个人轮流搬运芯片,芯片初始位于点s,谁最后五路可走谁输,但是在这场游戏中,后手在每次轮到他的时候他正好都在睡觉,于是先手都会偷偷帮他走,然后问你先手在最优状态下的结局,如果先手赢,要输出先手总共走的路径。

题解:其实翻译过来就是问你一个有向图中是否存在一条走奇数边能走到一个出度为0的点的路径,如果存在就输出路径,当然,假如不存在并且从s点走存在环,则一定就是平局,否则就是lose,因为题上说最多走1000000次,我们可以先广搜判断出环的情况,这样能先保证最坏也是平局,然后我们dfs爆搜,找先手能赢的路径,但是此时会出现问题,因为我有可能先走一个环,再往下走正好能走奇数个边(这里可以证明如果走环这个环一定只走一次),这也是我狂wa28的原因,因此我们可以开一个2维的标记数组,来标记当前点之前走了奇数条边或者走了偶数条边到达这里的,这样就能很好解决了,剩下的就是用last标记一下走过的路径即可。

	#include<queue>
	#include<vector>
	#include<stdio.h>
	#include<string.h>
	#include<algorithm>
	using namespace std;
	#define maxn 100005
	int n,m,last[maxn*10],vis[maxn][2],mark,s,sum;
	vector<int>q[maxn];
	queue<int>q1;
	void dfs(int u,int num)
	{
		if(mark==1) return;
		last[num]=u;vis[u][num%2]=1;
		for(int i=0;i<q[u].size();i++)
		{
			int v=q[u][i];
			if(vis[v][(num+1)%2])
				continue;
			dfs(v,num+1);
		}
		if(num%2 && q[u].size()==0)
		{
			sum=num;
			mark=1;
			return;
		}
		if(num%2==0 && mark==0)
		{
			mark=2;
			return;
		}
	}
	int main(void)
	{
		int x,num,cnt=0;
		scanf("%d%d",&n,&m);
		for(int i=1;i<=n;i++)
		{
			scanf("%d",&num);
			for(int j=1;j<=num;j++)
			{
				scanf("%d",&x);
				q[i].push_back(x);
			}
		}
		scanf("%d",&s);q1.push(s);
		while(q1.empty()==0)
		{
			int now=q1.front();q1.pop();
			for(int i=0;i<q[now].size();i++)
				cnt++,q1.push(q[now][i]);
			if(cnt>=1000000)
			{
				mark=3;
				break;
			}
		}
		dfs(s,0);
		if(mark==1)
		{
			printf("Win\n");
			for(int i=0;i<=sum;i++)
				printf("%d ",last[i]);
			printf("\n");
		}
		else if(mark==2)
			printf("Lose\n");
		else
			printf("Draw\n");
		return 0;
	}

评论 3
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值